DICParser Class Reference

Public class that respresents a dictionary parser. More...

`#include <DICParserBase.h>`

Inheritance diagram for DICParser:
Collaboration diagram for DICParser:

## Public Member Functions

| DICParser (DicFile *dicFileP, CifFile *ddlFileP, bool verbose=false)
void | Parse (const string &fileName, string &diagnostics)
virtual | ~DICParser ()
void | Error (const char *)
void | Clear ()
void | Reset ()
void | ProcessAssignments (void)
void | ProcessOneAssignment (void)
void | ProcessItemNameListLoop (void)
void | ProcessItemNameListName (void)
void | ProcessValueListItem (void)
void | ProcessItemName (void)
void | ProcessLoop (void)
void | ProcessItemValue (void)
void | ProcessLsItemValue (void)
void | ProcessUnknownValue (void)
void | ProcessMissingValue (void)
void | ProcessSaveBegin (void)
void | ProcessSaveEnd (void)
void | ProcessDataBlockName (void)
Public Member Functions inherited from DICScanner
| DICScanner (std::istream *yyin)
| DICScanner ()
void | Clear ()
void | Reset ()
int | ProcessNone ()
void | ProcessWhiteSpace ()
int | ProcessData ()
int | ProcessItemSaveBegin ()
int | ProcessCategorySaveBegin ()
int | ProcessSaveEndScanner ()
int | ProcessLoopScanner ()
void | ProcessStop ()
int | ProcessDot ()
int | ProcessQuestion ()
void | ProcessComment ()
int | ProcessItemNameScanner ()
int | ProcessUnquotedString ()
int | ProcessSQuotedString ()
int | ProcessDQuotedString ()
int | ProcessEof ()
virtual int | yylex ()
virtual | ~DICScanner ()

## Additional Inherited Members

Public Attributes inherited from DICScanner
int | NDBlineNo
int | isSave
Protected Member Functions inherited from DICScanner
void | alt_yymore (void)
void | OpenLog (const std::string &logName, bool verboseLevel)
Protected Attributes inherited from DICScanner
std::string * | _tBuf
int | _isText
int | _i
int | _j
int | _len
std::ofstream | log
bool | _verbose

## Detailed Description

Public class that respresents a dictionary parser.

This class represents a dictionary parser. This class utilizes flex/bison for syntax/semantic processing and stores the parsed data (dictionary blocks and tables) in a DicFile object.

## Constructor & Destructor Documentation

## DICParser()

DICParser::DICParser | ( | DicFile * | dicFileP,
|  | CifFile * | ddlFileP,
|  | bool | verbose = `false`
| ) |  |

Constructs a dictionary parser.

Parameters

  [in] | dicFileP | - pointer to the DicFile object that the dictionary parser is to use to store the parsed data
  [in] | ddlFileP | - pointer to the CifFile object that holds the DDL for the dictionary
  [in] | verbose | - optional parameter that indicates whether parsing logging should be turned on (if true) or off (if false). If verbose is not specified, logging is turned off.

Returns
  Not applicable

Precondition
  dicFileP must not be NULL
  ddlFileP must not be NULL

Postcondition
  None

Exceptions

  EmptyValueException | - if dicFileP is NULL
  EmptyValueException | - if ddlFileP is NULL

## ~DICParser()

virtual DICParser::~DICParser | ( |  | ) |

virtual

Destructs a dictionary parser by releasing all the used resources.

Parameters

  | Not applicable

Returns
  Not applicable

Precondition
  None

Postcondition
  None

Exceptions

None

## Member Function Documentation

## Clear()

void DICParser::Clear | ( |  | ) |

Method, not currently part of users public API, and will soon be re-examined.

## Error()

void DICParser::Error | ( | const char * |  | ) |

Utility method, not part of users public API, and will soon be removed.

## Parse()

void DICParser::Parse | ( | const string & | fileName,
|  | string & | diagnostics
| ) |  |

Parses a dictionary file.

Parameters

  [in] | fileName | - relative or absolute name of the dictionary file that is to be parsed.
  [out] | diagnostics | - parsing result. If empty, parsing completed with no warnings or errors. If non-empty, there were parsing warnings and/or parsing errors.

Returns
  None

Precondition
  None

Postcondition
  None

Exceptions

None

## ProcessAssignments()

void DICParser::ProcessAssignments | ( | void |  | ) |

Utility method, not part of users public API, and will soon be removed.

## ProcessDataBlockName()

void DICParser::ProcessDataBlockName | ( | void |  | ) |

Utility method, not part of users public API, and will soon be removed.

## ProcessItemName()

void DICParser::ProcessItemName | ( | void |  | ) |

Utility method, not part of users public API, and will soon be removed.

## ProcessItemNameListLoop()

void DICParser::ProcessItemNameListLoop | ( | void |  | ) |

Utility method, not part of users public API, and will soon be removed.

## ProcessItemNameListName()

void DICParser::ProcessItemNameListName | ( | void |  | ) |

Utility method, not part of users public API, and will soon be removed.

## ProcessItemValue()

void DICParser::ProcessItemValue | ( | void |  | ) |

Utility method, not part of users public API, and will soon be removed.

## ProcessLoop()

void DICParser::ProcessLoop | ( | void |  | ) |

Utility method, not part of users public API, and will soon be removed.

## ProcessLsItemValue()

void DICParser::ProcessLsItemValue | ( | void |  | ) |

Utility method, not part of users public API, and will soon be removed.

## ProcessMissingValue()

void DICParser::ProcessMissingValue | ( | void |  | ) |

Utility method, not part of users public API, and will soon be removed.

## ProcessOneAssignment()

void DICParser::ProcessOneAssignment | ( | void |  | ) |

Utility method, not part of users public API, and will soon be removed.

## ProcessSaveBegin()

void DICParser::ProcessSaveBegin | ( | void |  | ) |

Utility method, not part of users public API, and will soon be removed.

## ProcessSaveEnd()

void DICParser::ProcessSaveEnd | ( | void |  | ) |

Utility method, not part of users public API, and will soon be removed.

## ProcessUnknownValue()

void DICParser::ProcessUnknownValue | ( | void |  | ) |

Utility method, not part of users public API, and will soon be removed.

## ProcessValueListItem()

void DICParser::ProcessValueListItem | ( | void |  | ) |

Utility method, not part of users public API, and will soon be removed.

## Reset()

void DICParser::Reset | ( |  | ) |

Method, not currently part of users public API, and will soon be re-examined.

The documentation for this class was generated from the following file:

- rcsb/DICParserBase.h